
public class PriorityQueue
{
	private Node<BinNode<CharFreq>> head;

	public PriorityQueue ()
	{
		this.head=null;
	}

	public void insert(BinNode<CharFreq> current)
	{
		Node<BinNode<CharFreq>> pos=this.head;
		if (pos==null || pos.getValue().getValue().getFreq()>current.getValue().getFreq())
			this.head=new Node <BinNode<CharFreq>> (current,this.head);
		else
		{
			while (pos.hasNext() && pos.getNext().getValue().getValue().getFreq()<=current.getValue().getFreq())
				pos=pos.getNext();
			pos.setNext(new Node<BinNode<CharFreq>>(current,pos.getNext()));
		}
	}

	public BinNode<CharFreq> remove()
	{
		BinNode<CharFreq> x=this.head.getValue();
		this.head=this.head.getNext();
		return x;
}

	public BinNode<CharFreq> head()
	{
		return this.head.getValue();
	}

	public boolean isEmpty()
	{
		return this.head==null;
	}	

	public String toString()
	{
		Node<BinNode<CharFreq>> pos=this.head;
		String str="";
		while (pos.hasNext())
		{
			str+=pos.getValue().getValue().toString()+" , ";
			pos=pos.getNext();
		}
		return str+pos.getValue().getValue().toString();
	}
}
